Name: majordomo
Version: 1.94.5
Release: 2
Group: Applications/Internet
Source: ftp://ftp.greatcircle.com/pub/majordomo/1.94.4/majordomo-1.94.5.tar.bz2
Source1: majordomo.cf
Source2: bulk_mailer-1.9.tar.bz2
Source3: MajorDomoCreate
Source4: README.redhat
#Patch: majordomo-1.94.4.security.patch
Patch1: majordomo-1.94.4.opt.patch
Patch2: bulk_mailer-1.9-opt.patch
#Patch3: new-security.patch
Copyright: Greatcircle's see LICENCE in docs
Summary: A list management program that uses e-mail for list administration.
BuildRoot: /var/tmp/majordomo/
Provides: bulk_mailer
Requires: shadow-utils
URL: http://www.greatcircle.com/majordomo/

%description
Majordomo is a list management program which uses e-mail to handle all
aspects of list maintenance. Once a list is set up, virtually all
operations can be performed remotely, requiring no intervention by the
postmaster of the list site (and list owners won't need access to the
server that Majordomo is on). Majordomo controls a list of addresses
which a mail transport system (like sendmail or smail) handles.
Majordomo itself performs no mail delivery, but it has scripts to
format and archive messages.

%prep
%setup
# %patch -p1
%patch1 -p1
%setup -T -D -a 2 
%patch2 -p1
#%patch3 -p1

%build
W_ALL="PERL=/usr/bin/perl \
CC=gcc \
W_USER=91 \
W_GROUP=91 \
W_PATH=/bin:/usr/bin \
W_MAJORDOMO_CF=/etc/majordomo.cf \
W_HOME=/usr/lib/majordomo \
MAN=/usr/man"

RPM_OPT_FLAGS=${RPM_OPT_FLAGS} make ${W_ALL} wrapper
strip wrapper

# do bulk_mailer
( cd bulk_mailer
./configure
RPM_OPT_FLAGS=${RPM_OPT_FLAGS} make
)

%install
rm    -fr ${RPM_BUILD_ROOT}
mkdir ${RPM_BUILD_ROOT}/{,etc/{,logrotate.d},usr/{,sbin,doc,man/{,man{1,8}},lib/{,majordomo/{,contrib}}},var/{,lib/{,majordomo/{,OLDLOGS,archives,digest,lists,tmp}}}}

# user majordomo needs to exist at build time
if `useradd -M -r -u 91 -d /usr/lib/majordomo -s /bin/bash majordomo` ; then
touch ${RPM_BUILD_ROOT}/.added
fi

# redefine 
W_ALL="PERL=/usr/bin/perl \
CC=gcc \
W_USER=91 \
W_GROUP=91 \
W_PATH=/bin:/usr/bin \
W_MAJORDOMO_CF=/etc/majordomo.cf \
W_HOME=${RPM_BUILD_ROOT}/usr/lib/majordomo \
MAN=${RPM_BUILD_ROOT}/usr/man"


make $W_ALL install
make $W_ALL install-wrapper

# for testing
# ( cd ${W_HOME}
# ./wrapper config-test )
# mv -bv ${W_HOME}/majordomo.cf ${RPM_BUILD_ROOT}/etc/majordomo.cf

# fix perms prob
chown -R 0.0   ${RPM_BUILD_ROOT}/usr/man
chown -R 91.91 ${RPM_BUILD_ROOT}/var/lib/majordomo
# added mail to group
for i in ../majordomo archives digest lists tmp
do
chmod 750 ${RPM_BUILD_ROOT}/var/lib/majordomo/$i 
done

# put in our own .cf and don't confuse things
install -m444 ${RPM_SOURCE_DIR}/majordomo.cf ${RPM_BUILD_ROOT}/etc
rm -fv ${RPM_BUILD_ROOT}/usr/lib/majordomo/majordomo.cf 

echo "/var/lib/majordomo/log {
weekly
compress
delaycompress
olddir /var/lib/majordomo/OLDLOGS
rotate 52
create 640 majordomo majordomo
olddir /var/lib/majordomo
}" >>${RPM_BUILD_ROOT}/etc/logrotate.d/majordomo

install -s -m555 bulk_mailer/bulk_mailer   ${RPM_BUILD_ROOT}/usr/sbin
install    -m444 bulk_mailer/bulk_mailer.1 ${RPM_BUILD_ROOT}/usr/man/man1

install    -m555 /${RPM_SOURCE_DIR}/MajorDomoCreate /${RPM_BUILD_ROOT}/usr/lib/majordomo/contrib

mkdir -p $RPM_BUILD_ROOT/etc/smrsh
(cd $RPM_BUILD_ROOT/etc/smrsh
	ln -sf ../../usr/lib/majordomo/wrapper wrapper
)

%pre
groupadd -g 91 majordomo
useradd -M -r -u 91 -g 91 -d /usr/lib/majordomo -s /bin/bash -c "Majordomo List Manager" majordomo 
usermod  -G majordomo mail
cp /etc/aliases /etc/aliases.rpmsave
echo -e majordomo: \""|/usr/lib/majordomo/wrapper majordomo\"" >> /etc/aliases
newaliases

%postun
mv -f /etc/aliases.rpmsave /etc/aliases
newaliases
userdel majordomo
groupdel majordomo


%clean
#  this removes the username if we added it, check this after a failed compile
#  Is there a way to set a variable across spec sections?
if [ -f ${RPM_BUILD_ROOT}/.added ] ; then
userdel majordomo
groupdel majordomo
fi
make clean
rm    -fr $RPM_BUILD_ROOT/

%files
%config /etc/majordomo.cf
%doc Changelog FUTURE INSTALL LICENSE NEWLIST NEWS README todo.local
%doc Doc/* bulk_mailer/bulk_mailer.README $RPM_SOURCE_DIR/README.redhat 
/etc/logrotate.d/majordomo
/usr/lib/majordomo
/usr/man/*/*
/usr/sbin/bulk_mailer
/var/lib/majordomo
/etc/smrsh/wrapper

%changelog
* Thu Jan 20 2000 Tim Powers <timp@redhat.com>
- updated to 1.94.5, security fixes.
- added README.redhat
- fixed missing link, should have been /etc/smrsh/wrapper -> /usr/lib/majordomo/wrapper

* Wed Jan 19 2000 Tim Powers <timp@redhat.com>
- gendiffed the patch submitted by Olaf Kirch <okir@ns.lst.de> to fix the
	local user exploit of the wrapper.
- removed stupid echos from the pre and postun sections
- bzipped some of the sources

* Mon Aug 30 1999 Tim Powers <timp@redhat.com>
- changed group

* Fri Aug 6 1999 Tim Powers <timp@redhat.com>
- changed buildroot from /usr/tmp to /var/tmp
- moved changelog to bottom for consistancy with other packages in Powertools
- rebuilt for inclusion into Powertools 6.1

* Tue Oct 13 1998 Christopher McCrory <chrismcc@netus.com>
- added user mail(sendmail user) to group majordomo via pre install script
- and made directories /var/lib/majordomo/* 750

* Wed May 20 1998 Christopher McCrory <chrismcc@netus.com>
- added better opt, but needed to patch Makefile :(
- finished adding bulk_mailer mail optimizer

* Tue May 19 1998 Christopher McCrory <chrismcc@netus.com>
- tweeked majordomo.cf
- moved /usr/lib/majordomo-version to plain /usr/lib/majordomo
- moved /usr/lib/majordomo/lists to /var/lib/majordomo
- upgraded install will have to be moved by hand, to much chance of failure
- added useradd/userdel scripts ( stolen from postgres spec file)
- used useradd/userdel during build with check
- added logrotate script

* Tue May 05 1998 Christopher McCrory <chrismcc@netus.com>

- added buildroot
- note: installs as uid/gid 91, this must be a valid user at build time
- todo: put lists in /var/lib
- todo: fix up majordomo.cf

* Mon Apr 06 1998 Christopher McCrory <chrismcc@netus.com>

- one last compile, just to make sure...
- have NOT tested in production use (this is prep for sys upgrade)

* Sun Apr 05 1998 Christopher McCrory <chrismcc@netus.com>

- started spec file
- changed defaults to UID=90 GID=90 homedir=/usr/lib/majordomo-1.94.4
- changed a few /bin/sh to /bin/bash (faster ?)
- put majordomo.cf in /etc
- TODO: %pre and %post scripts to get local domain name for .cf file, add
  majordomo user, build bulk_mailer rpm, auto generate .cf file, more ??
- added Steven Pritchard's (steve@silug.org) tmp security patch
